SystemOrganization addCategory: #'JQWidgetBox-AlphaNumeric-Dev-Tests'!
SystemOrganization addCategory: #'JQWidgetBox-AlphaNumeric-Dev-Examples'!

JQWidgetBoxWidgetTest subclass: #JQAlphaNumericTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-AlphaNumeric-Dev-Tests'!

!JQAlphaNumericTest methodsFor: 'testing' stamp: 'tbn 11/2/2009 15:44'!
testModes

	self
		assert: ((self jQuery: 'sample') alphanumeric)
		equals: self function , '("sample").alphanumeric()'.
		
	self
		assert: ((self jQuery: 'sample') numeric)
		equals: self function , '("sample").numeric()'.
		
	self
		assert: ((self jQuery: 'sample') alpha)
		equals: self function , '("sample").alpha()'.			! !

JQWidgetExample subclass: #JQAlphaNumericExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-AlphaNumeric-Dev-Examples'!

!JQAlphaNumericExample classSide methodsFor: 'accessing' stamp: 'tbn 11/2/2009 15:58'!
description
	^ 'JQuery AlphaNumeric'! !

!JQAlphaNumericExample classSide methodsFor: 'accessing' stamp: 'tbn 11/2/2009 15:58'!
shortName
	^'alphanumeric'! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:18'!
renderAlphaNumericOnlyOn: html

	|id|
	id := html nextId.
	html label: 'Alphanumeric only'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) alphanumeric).
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:17'!
renderAlphaOnlyOn: html

	|id|
	id := html nextId.
	html label: 'Alpha only'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) alpha).
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:18'!
renderCapitalLettersOnlyOn: html

	|id|
	id := html nextId.
	html label: 'Capital letters alpha only'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) alpha allcaps: true).
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 15:59'!
renderContentOn: html
	
	self 
		renderNumericOnlyOn: html;
		renderAlphaNumericOnlyOn: html;
		renderAlphaOnlyOn: html;
		renderLowercaseOnlyOn: html;
		renderCapitalLettersOnlyOn: html;
		renderExemptedCharactersOn: html;
		renderCustomSetOfCharactersOn: html! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:18'!
renderCustomSetOfCharactersOn: html

	|id|
	id := html nextId.
	html label: 'Custom set of characters (prevent 1 and 0 here)'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) alphanumeric ichars: '01').
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:18'!
renderExemptedCharactersOn: html

	|id|
	id := html nextId.
	html label: 'Alpha only (but with space, dot and colon)'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) alpha allow: ';. ').
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:18'!
renderLowercaseOnlyOn: html

	|id|
	id := html nextId.
	html label: 'Lowercase alpha only'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) alpha nocaps: true).
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 16:18'!
renderNumericOnlyOn: html

	|id|
	id := html nextId.
	html label: 'Numeric only'; space.
	html textInput 		
		id: id;
		script: ((html jQuery id: id) numeric).
	html horizontalRule 
! !

!JQAlphaNumericExample methodsFor: 'updating' stamp: 'tbn 11/2/2009 16:06'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: self library / #jqueryalphanumericpackJs! !

!JQWidgetBoxLibrary methodsFor: '*jqwidgetbox-alphanumeric-dev' stamp: ''!
jqueryalphanumericJs
	^ '(function($){

	$.fn.alphanumeric = function(p) { 

		p = $.extend({
			ichars: "!!@#$%^&*()+=[]\\\'';,/{}|\":<>?~`.- ",
			nchars: "",
			allow: ""
		  }, p);	

		return this.each
			(
				function() 
				{

					if (p.nocaps) p.nchars += "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
					if (p.allcaps) p.nchars += "abcdefghijklmnopqrstuvwxyz";
					
					s = p.allow.split('''');
					for ( i=0;i<s.length;i++) if (p.ichars.indexOf(s[i]) !!= -1) s[i] = "\\" + s[i];
					p.allow = s.join(''|'');
					
					var reg = new RegExp(p.allow,''gi'');
					var ch = p.ichars + p.nchars;
					ch = ch.replace(reg,'''');

					$(this).keypress
						(
							function (e)
								{
								
									if (!!e.charCode) k = String.fromCharCode(e.which);
										else k = String.fromCharCode(e.charCode);
										
									if (ch.indexOf(k) !!= -1) e.preventDefault();
									if (e.ctrlKey&&k==''v'') e.preventDefault();
									
								}
								
						);
						
					$(this).bind(''contextmenu'',function () {return false});
									
				}
			);

	};

	$.fn.numeric = function(p) {
	
		var az = "abcdefghijklmnopqrstuvwxyz";
		az += az.toUpperCase();

		p = $.extend({
			nchars: az
		  }, p);	
		  	
		return this.each (function()
			{
				$(this).alphanumeric(p);
			}
		);
			
	};
	
	$.fn.alpha = function(p) {

		var nm = "1234567890";

		p = $.extend({
			nchars: nm
		  }, p);	

		return this.each (function()
			{
				$(this).alphanumeric(p);
			}
		);
			
	};	

})(jQuery);
'! !
